######################################################
# psyBNC_v1.3.tcl              http://tcls.dhcp.biz  #
#                                                    #
# MyCraft                           (c) 2003 Dez 17  #
# EMail                             MyCraft@gmx.net  #
######################################################
##
# NOTE: Since psyBNC2.3.2-x it sends PRIVMSG to the user insteed NOTICE
#       So this script only works with such versions of psyBNC!
#       Get my old psyBNC.tcl to use it with older psyBNC versions
#
# Boolean options (those that have a "yes" or "no" answer should have
# the following values:
#       0 = no  = false
#       1 = yes = true
#
# If a key is specified more than once, the key toward the bottom of the
# file will take precedence.
#
# Add this script to your botconf like:
#
# if {[catch { source scripts/psyBNC_v1.3.tcl } fId]} { putlog "$fId" }
##
#### About this script:
##
# With this scrtipt your bot can connect to a psyBNC  and manage it also
# over dcc commands (global bot-master's only).
#
# Also it logs all messages from psyBNC user (nick: -psyBNC) to a local
# file. You can read and erase that file. So if your bot dies but the
# psyBNC is still up and anyone msg's the psyBNC, its logged...
#
# Try ' .psybnc help ' for the dcc commands.
##
#### Options:
#
## Password on psyBNC:
#
set psyBNC(pass) "XXXX"

## Vhost to use with psyBNC:
#
set psyBNC(vhost) "some.vhost.or.ip.org"

## Connect to IRC-Server with SSL ?
# 1 = yes / 0 = no
#
set psyBNC(SSL) "0"

## Servers to connect to with psyBNC:
# NOTE: Seperate the Server with Spaces. Like:
# "irc.server1.net irc.server2.com irc.server3.de"
#
set psyBNC(server) "irc.Qeast.net irc.du.se irc.homelien.no efnet.vuurwerk.nl"

## Set the default IRC-Server Port:
# NOTE: SSL IRC-Server most uses port 7000
#
set psyBNC(srvport) "6667"

## Leave msg to be posted when the Bot Restarts/Died
# 0 = disabled
#
set psyBNC(leave) "Restarted/Died"

## Away msg to use when the Bot Restarts/Died
# 0 = disabled
#
set psyBNC(away) "Restarted/Died"

## Do you want that the Bot leaves the Chans when he Restarts/Died ?
# NOTE: bot leaves channels sometimes on restart. i cant fix that :(
# 1 = yes / 0 = no
#
set psyBNC(lquit) "0"     

## putlog what psyBNC.tcl does?
# 1 = yes / 0 = no
#
set psyBNC(putl0g) "1"

## Write all messages from psyBNC to a log?
# Note that this file can get big!
# You should do ' .psybnc readlog / eraselog ' sometimes!
# 1 = yes / 0 = no
#
set psyBNC(SaveMSGs) "1"

## This sets the OutPut line prefix. e.g.: 'putlog "text"'
# NOTE: no need to change this yet. only the dcc-commands proc uses it
# 1 = putlog / 2 = PSYplg (proc) / 3 = putdcc $idx (if exist)
#
set psyBNC(OPLp) "1"


#### End Options
###
##
# Version history:
#
# 1.3  - ReCoded whole script coz newer psyBNC uses to msg the user insteed notice
#      - Added '.psybnc readlog/eraselog' -> All messages from psyBNC gets logged
#        into a file. So you can check later if theres something wrong or anyone
#        msgd the bot where it was down
#
# 1.07  - Fixd some more major bugs with the psyBNC2.3.1
#       - Changed ALL dcc commands to one simple bundle -> .psybnc
#       ...thats why i jumped to v1.07 :>
#
# 1.05  - Fixd some major bugs in the changes from 1.03 (thx to [horse] for testing)
#
# 1.04  - Some little changes
#
# 1.03  - I tryd to solve this tcl error on some shells for n00bs :P
#
# older - dunno :P
#
##
###
#### >>> >> >  DO NOT MESS WiTH ANYTHiNG BELOW THiS LiNE!  < << <<< ####
#### -------------------------------------------------------------- ####


bind dcc m|- psybnc psyBNC:commands
bind msgm - * psyBNC:GettingMSG
bind notc - "*Please type /QUOTE PASS yourpassword*" psyBNC:notc:pass
bind notc - "*cant connect to*" psyBNC:notc:recon


set psyBNC(IND) 0
set psyBNC(maxserv) 0
set psyBNC(DELSRV) 0
set psyBNC(Scv) "1.3"
set Lpath "[file join [pwd]]/scripts"
set psyBNC(LogFile) "$Lpath/.psyBNC.log"
foreach PSR0 $psyBNC(server) { incr psyBNC(maxserv) 1 }
if {![info exist $psyBNC(srvport)]} { set psyBNC(srvport) "6667" }
proc b { } { return "\002" }; #bold


if {$psyBNC(OPLp) == "1"} {
     set psyBNC(OPLp) "putlog"
   } elseif {$psyBNC(OPLp) == "2"} {
     set psyBNC(OPLp) "PSYplg"
   } elseif {$psyBNC(OPLp) == "3"} {
     set psyBNC(OPLp) "putdcc $idx"
   } else {
     set psyBNC(OPLp) "putlog"
}


proc psyBNC:notc:pass {nick uhost hand text {dest ""}} {
  global psyBNC
  putquick "PASS $psyBNC(pass)"
  if {$psyBNC(lquit) != ""}  { putquick "LEAVEQUIT $psyBNC(lquit)" }
  if {$psyBNC(vhost) != ""}  { putquick "BVHOST $psyBNC(vhost)" }
  if {$psyBNC(leave) != "0"} { putquick "SETLEAVEMSG $psyBNC(leave)" }
  if {$psyBNC(away) != "0"}  { putquick "SETAWAY $psyBNC(away)" }
}


proc psyBNC:GettingMSG {nick uhost hand arg} {
  global psyBNC
  if {$nick != "-psyBNC"} { return 0 }
  if {$psyBNC(SaveMSGs) == "1"} {
       if {[string match "\[0-9\]\[0-9\]\:\[0-9\]\[0-9\]\:\[0-9\]\[0-9\]" [lindex $arg 3]]} {
            set OPL "$arg"
          } else {
            set OPL "[clock format [clock seconds] -format "%a %b %d %H:%M:%S"] $arg"
          }
       set Lpath "[file join [pwd]]/scripts"
       set tmpfile [open $Lpath/.psyBNC.log a]
       puts $tmpfile "$OPL"
       catch { close $tmpfile }
     }
  if {[string match -nocase "*has no server added*" $arg]} {
       set serv [lindex $psyBNC(server) $psyBNC(IND)]
       incr psyBNC(IND) 1
       if {$psyBNC(SSL) == "1"} { set serv "S\=$serv" }
       putserv "ADDSERVER $serv\:$psyBNC(srvport)"
       if {$psyBNC(IND) == "$psyBNC(maxserv)"} { set psyBNC(IND) 0 }
       PSYplg "... Server [b]$serv:$psyBNC(srvport)[b] Added to Serverlist ..."
     }
  if {[string match -nocase "you have messages.*" $arg]} { putserv "PLAYPRIVATELOG" }
  if {[string match -nocase "use eraseprivatelog to kill the log*" $arg]} { putserv "ERASEPRIVATELOG" }
  if {([string match -nocase "server \#*:*port*" $arg]) && ($psyBNC(DELSRV) == "1")} {
       set ServNum [string map {\# "" \: ""} [lindex $arg 1]]
       putquick "DELSERVER $ServNum"
       PSYplg "... Deleted $arg"
     }
  if {([string match -nocase "end of servers.*" $arg]) && ($psyBNC(DELSRV) == "1")} {
       set psyBNC(DELSRV) 0
       psyBNC:AddNewServer
     }
}


proc psyBNC:notc:recon {nick host hand text} {
  global psyBNC
  PSYplg "... Deleting old Serverlist ..."
  set psyBNC(DELSRV) 1
  putserv "LISTSERVERS"
}


proc psyBNC:AddNewServer { } {
  global psyBNC
  set serv [lindex $psyBNC(server) $psyBNC(IND)]
  incr psyBNC(IND) 1
  if {$psyBNC(SSL) == "1"} { set serv "S\=$serv" }
  putserv "ADDSERVER $serv\:$psyBNC(srvport)"
  if {$psyBNC(IND) == "$psyBNC(maxserv)"} { set psyBNC(IND) 0 }
  PSYplg "... Server [b]$serv:$psyBNC(srvport)[b] Added to Serverlist ..."
}


proc psyBNC:commands {hand idx arg} {
  global psyBNC
  set command [string tolower [lindex $arg 0]]
  if {($command == "") || ($command == "help")} {
       ${psyBNC(OPLp)} "--psyBNC.tcl v$psyBNC(Scv) ... Command List:"
       ${psyBNC(OPLp)} "  "
       ${psyBNC(OPLp)} ".psybnc lserv ....................... to list all added servers"
       ${psyBNC(OPLp)} ".psybnc delserv (<\#>) ............... to del the first 5 added servers or the given number"
       ${psyBNC(OPLp)} ".psybnc jump ........................ to jump to the next server in list"
       ${psyBNC(OPLp)} ".psybnc addserv <server> (<port>) ... to add a new server to list. without args to get help"
       ${psyBNC(OPLp)} ".psybnc set <setting> ............... to set own settings on the psybnc"
       ${psyBNC(OPLp)} ".psybnc readlog/eraselog ............ to read or erase the logfile where all msgs from psyBNC are saved"
       ${psyBNC(OPLp)} "    "
       ${psyBNC(OPLp)} "--psyBNC.tcl ... Command List -END-"
       return 1
     }
  switch -exact $command {
         "lserv" { putserv "LISTSERVERS" ; return 1 }
          "jump" { putserv "JUMP" ; return 1 }
           "set" {
                   set vari [lrange $arg 1 end]
                   if {$vari == ""} {
                        ${psyBNC(OPLp)} "--psyBNC.tcl : Usage: .psybnc set <setting>"
                        return 0
                      }
                   putserv "$vari"
                   return 1
                 }
       "addserv" {
                   set new_server [lindex $arg 1]
                   set new_port [lindex $arg 2]
                   if {$new_server == ""} {
                        ${psyBNC(OPLp)} "--psyBNC.tcl : Usage: .psybnc addserv <server> (<port>)"
                        return 0
                      }
                   if {$new_port == ""} { set new_port $psyBNC(srvport) }
                   putserv "ADDSERVER $new_server \:$new_port"
                   ${psyBNC(OPLp)} "--psyBNC.tcl ... Server [b]$new_server:$new_port[b] Added to Serverlist ..."
                   return 1
                 }
       "delserv" {
                   if {[lindex $arg 1] != ""} {
                        putserv "DELSERVER $arg"
                      } else {
                        putserv "DELSERVER 0"
                        putserv "DELSERVER 1"
                        putserv "DELSERVER 2"
                        putserv "DELSERVER 3"
                        putserv "DELSERVER 4"
                        putserv "DELSERVER 5"
                      }
                   return 1
                 }
       "readlog" {
                   if {![file exist $psyBNC(LogFile)]} { ${psyBNC(OPLp)} "--psyBNC.tcl : No such file: $psyBNC(LogFile)" ; return 1 }
                   set tmpfile [open $psyBNC(LogFile) r]
                   while {![eof $tmpfile]} {
                           if {[eof $tmpfile]} {break}
                           set tmp [gets $tmpfile]
                           if {$tmp == ""} {continue}
                           ${psyBNC(OPLp)} "$tmp"
                         }
                   catch { close $tmpfile }
                   return 1
                 }
       "logread" { psyBNC:commands $hand $idx readlog ; return 0 }
      "eraselog" {
                   if {![file exist $psyBNC(LogFile)]} { ${psyBNC(OPLp)} "--psyBNC.tcl : No such file: $psyBNC(LogFile)" ; return 1 }
                   catch { file delete -force "$psyBNC(LogFile)" } PSYLDEr
                   ${psyBNC(OPLp)} "psyBNC log erased $PSYLDEr"
                   return 1
                 }
     "deletelog" { psyBNC:commands $hand $idx eraselog ; return 0 }
      "logerase" { psyBNC:commands $hand $idx eraselog ; return 0 }
        "dellog" { psyBNC:commands $hand $idx eraselog ; return 0 }
   }
  psyBNC:commands $hand $idx help
}

set strict-servernames 0
set servlimit 1

proc PSYplg {text} { global psyBNC ; if {$psyBNC(putl0g) != "0"} { putlog "--psyBNC.tcl : $text" } }

putlog "++++ [b]--psyBNC.tcl[b] v$psyBNC(Scv) by MyCraft (try .psybnc for help) ++++"

